clear all;
h = hadamard(4);
Hi = [-10 0 0 0;
       0 -40 0 0;
       0 0 -5 0;
       0 0 0 -12];

Hi = h*Hi*h';

Hm1 = [-3 0 0 0;
       0 -2 0 0;
       0 0 -1 0;
       0 0 0 -0.5];

Hm2= [-5 0 0 0;
      0 -12 0 0;
      0 0 -15 0;
      0 0 0 -20];

p = 1
x = [1 -1 1 -1]';

c = 0;
for f = 0:1/1000:1
    c = c+1;
    H = ((1-f)^p)*Hi + (f^p)*Hm1;

    e = eig(H);
        
    x = H*x;
    x = x/norm(x);
end
%------------------------------
%-----removing constraints-----
Hm1 = h*Hm1*h';

c=0
%x=[1 1 1 1]';

for f = 0:1/100:1
    c = c+1;
    H = ((1-f)^p)*Hm1 + (f^p)*Hm2;
 
    x = H*x;
    x = x/norm(x);
    [v,e] = eig(H);
    d = eig(H);
    
    f11 = v\x;
    f11 = f11/norm(f11);
    stem(d,abs(f11),'r','*'), axis ([-60 0 -0.01 2]),grid on;

    F(c) = getframe;
    
  end
%------------------------------
movie(F,1,2)
H;
[v,e]=eig(H)
x;

% 
% G = hadamard(8);
% ff = [-1 -1 -1 1 1 1 1 -1]';
% G*ff;
% P = [2 0 0 0;
%      0 4 0 0;
%      0 0 5 0;
%      0 0 0 3];
% 
%  [e] = eig(P);
%  f = [1 0.5 2 0.3];
%  
%  %stem(e,f),axis([0 6 0 4])
%  
%  H = hadamard(4);
%  
%  Z = peaks; surf(Z); 
% axis tight
% set(gca,'nextplot','replacechildren');
% % Record the movie
% for j = 1:20 
%     f = H*f;
%     
% % 	surf(sin(2*pi*j/20)*Z,Z)
% 	F(j) = getframe;
% end
% % Play the movie ten times
% movie(F,10)

