function H = Gen_Hamiltonian(vector)

N = length(vector);
%----Pauli Z matrix----
Z = [1 0;0 -1];
%----start your engine---
H = 0;
L = ceil(log2(N));
for i = 0:N-1
    c = d2b(i,L);
    F = 1;
    for j = 1:length(c) % read bit string
        J = eye(2)+ power(-1,c(j))*Z;
        F = kron(F,J);
    end        
    H = H - vector(i+1)*F;
end
H = H/2^L;
end