function y = d2b(x,N)
%This function converts whole number x into
%its N bit binary equivalent
res=0;
i=1;
while (x>0)
    R = mod(x,2);
    x = floor(x/2);
    res(i) = R;
    i = i+1;
end

    i = 1:length(res);
    y = res(length(res)+1-i);

if(N<length(y))
    warning('truncation to fewer bits');
    y = y(1:N);
else
    y = [zeros(1,N-length(y)) y];
end
